Con                                                         
                                                         
  _CLKMODE = XTAL1 + PLL16X                              
  _XINFREQ = 5_000_000
  
  PINGPIN = 17     ''ping sensor
  SRVPINR = 18     ''right wheel servo
  SRVPINL = 19     ''left wheel servo
  PNGSRV  = 16     ''ping sensor servo
  STOP    = 1500   ''servo stop and center value
             
Var

  long dst[2]
     
Obj                                                      
    
  echo : "ping" 
   srv : "servo32v7"
    
Pub Main 
  srv.set(PNGSRV, STOP)            'ping looking forward
  srv.set(SRVPINL, STOP)           'wheels stop
  srv.set(SRVPINR, STOP)           '
  srv.start                        'start servo object
  waitcnt(clkfreq + cnt)           'wait one second
  
  repeat
    dst := echo.centimeters(PINGPIN)
    if dst < 27
      reverse
      pause(400)
      stop_wheels 
      sonar      
    forward
                     
Pub Forward

  srv.set(SRVPINL, 1600)
  srv.set(SRVPINR, 1400)

Pub Pause(milliseconds)

  milliseconds *= (clkfreq/1000)
  waitcnt(milliseconds + cnt)
   
Pub Reverse

  srv.set(SRVPINL, 1400)
  srv.set(SRVPINR, 1600)  

Pub Stop_Wheels

  srv.set(SRVPINL, STOP)
  srv.set(SRVPINR, STOP)
    
Pub Turn_Left

  srv.set(SRVPINL, 1400)
  srv.set(SRVPINR, 1400)

Pub Turn_Right

  srv.set(SRVPINL, 1600)   
  srv.set(SRVPINR, 1600)   
                     
Pub Sonar
    
  srv.set(PNGSRV, 1000)       'right side in dst[0]
  waitcnt(clkfreq + cnt)  
  dst[0] := echo.centimeters(PINGPIN)
  srv.set(PNGSRV, 2000)       'left side in dst[1]
  waitcnt(clkfreq + cnt)    
  dst[1] := echo.centimeters(PINGPIN)   
  srv.set(PNGSRV, 1500)       'set ping back to center
  if dst[0] > dst[1]
    turn_right
    pause(400)
    stop_wheels
  else
    turn_left
    pause(400)
    stop_wheels
  waitcnt(clkfreq + cnt)
  